# GradlePluginDevelopmentExtension

abstract class GradlePluginDevelopmentExtension

Configuration options for the org.gradle.plugin.devel.plugins.JavaGradlePluginPlugin.

Below is a full configuration example. Since all properties have sensible defaults, typically only selected properties will be configured.

        plugins {
            id 'java-gradle-plugin'
        }

        sourceSets {
            functionalTest
        }

        gradlePlugin {
            testSourceSets project.sourceSets.functionalTest
            plugins {
                helloPlugin {
                    id  = 'org.example.hello'
                    implementationClass = 'org.example.HelloPlugin'
                }
            }
        }

Content copied to clipboard

#### Since

2.13

#### See also

JavaGradlePluginPlugin

## Constructors

GradlePluginDevelopmentExtension
Link copied to clipboard
constructor(project: Project, pluginSourceSet: SourceSet, testSourceSet: SourceSet)

## Properties

pluginSourceSet
Link copied to clipboard
val pluginSourceSet: SourceSet

## Functions

getPlugins
Link copied to clipboard
abstract fun getPlugins(): NamedDomainObjectContainer<PluginDeclaration>
Returns the declared plugins.
getTestSourceSets
Link copied to clipboard
open fun getTestSourceSets(): Set<SourceSet>
Returns the source sets executing the functional tests with TestKit.
getVcsUrl
Link copied to clipboard
abstract fun getVcsUrl(): Property<String>
Returns the property holding the URL for the plugin's VCS repository.
getWebsite
Link copied to clipboard
abstract fun getWebsite(): Property<String>
Returns the property holding the URL for the plugin's website.
isAutomatedPublishing
Link copied to clipboard
open fun isAutomatedPublishing(): Boolean
Whether the plugin should automatically configure the publications for the plugins.
plugins
Link copied to clipboard
open fun plugins(action: Action<in NamedDomainObjectContainer<PluginDeclaration>>)
Configures the declared plugins.
setAutomatedPublishing
Link copied to clipboard
open fun setAutomatedPublishing(automatedPublishing: Boolean)
Configures whether the plugin should automatically configure the publications for the plugins.
testSourceSet
Link copied to clipboard
@Incubating
open fun testSourceSet(testSourceSet: SourceSet)
Adds some source sets to the collection which will be using TestKit.
testSourceSets
Link copied to clipboard
open fun testSourceSets(testSourceSets: Array<SourceSet>)
Provides the source sets executing the functional tests with TestKit.